package voicereco.gz.example;

import java.util.ArrayList;
import android.app.Activity;
import android.content.Intent;
import android.speech.RecognizerIntent;
import android.util.Log;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.IOnActivityResult;
import anywheresoftware.b4a.objects.collections.List;

@ShortName("VoiceReco")
@Version(1.0f)
public class VoiceReco {
	/*
	 * el evento es con minuscula!!
	 */
	
	
	public BA _ba;
	public String _eventName;
	
	public BA getba(){		
		return _ba;				
	}
		
	public void setba(BA tba){		
		_ba = tba;							
	}
	
	public void initialize(BA ba, String eventName){
		
		VoiceReco vr = new VoiceReco();		
		vr.setba(ba);					
		_eventName = "listen";
		this._ba = vr.getba();
		
	}

	public IOnActivityResult ion;

	  public void Listen(final BA ba) {

	    	Intent i = new Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH);
	    	String prompt = "say something:";
	    	String language = "es";
			if (prompt  != null && prompt.length() > 0)
	    		i.putExtra(RecognizerIntent.EXTRA_PROMPT, prompt);
	    	if (language != null && language.length() > 0)
	    		i.putExtra(RecognizerIntent.EXTRA_LANGUAGE, language);
	    	ion = new IOnActivityResult() {

	    		@SuppressWarnings("unchecked")        
	    		@Override        
	    		public void ResultArrived(int resultCode, Intent intent) {
	    			List list = new List();
	    			if (resultCode == Activity.RESULT_OK) {
	    				ArrayList<String> t = intent.getStringArrayListExtra(RecognizerIntent.EXTRA_RESULTS);
	    				if (t.size() > 0) {
	    					list.setObject((java.util.ArrayList)t);
	    				}
	    			}
	    			Log.d("GZR", _eventName + "_result");
	    			ba.raiseEvent(VoiceReco.this, _eventName + "_result",  list.IsInitialized(), list);
	    			//Log.d("GZR", list);
	    		}
	    	};
	    	ba.startActivityForResult(ion, i);
	    }

}
